﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
//using NUnit.Framework;
using Microsoft.VisualStudio.TestTools.UnitTesting;


namespace KataDictionaryReplacer
{
    [TestClass]
    public class KataDictionaryReplacerTest
    {
        [TestMethod]
        public void TestEmptyInputReturnsEmptyOutput()
        {
            // Arrange
            ReplacerComponent replacerComponent = new ReplacerComponent();
            Dictionary<string, string> rulesDictionary = new Dictionary<string, string>();
            string output;

            // Act
            output = replacerComponent.Replace("", rulesDictionary);

            // Assert
            Assert.AreEqual("", output);
        }


        [TestMethod]
        public void TestTokenIsReplacedByValueFromDictionary()
        {
            // Arrange
            ReplacerComponent replacerComponent = new ReplacerComponent();
            Dictionary<string, string> rulesDictionary = new Dictionary<string, string>();
            string output;

            // Act
            rulesDictionary.Add("temp", "temporary");
            output = replacerComponent.Replace("$temp$", rulesDictionary);
            
            // Assert
            Assert.AreEqual("temporary", output);
        }


        [TestMethod]
        public void TestTokensAreReplacedByValuesFromDictionary()
        {
            // Arrange
            ReplacerComponent replacerComponent = new ReplacerComponent();
            Dictionary<string, string> rulesDictionary = new Dictionary<string, string>();
            string output;
            string input = "$temp$ here comes the name $name$";

            // Act
            rulesDictionary.Add("temp", "temporary");
            rulesDictionary.Add("name", "John Doe");
            output = replacerComponent.Replace(input, rulesDictionary);

            // Assert
            Assert.AreEqual("temporary here comes the name John Doe",
                output);
        }
    }
}