﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace KataPotter.Tests
{
    [TestClass]
    public class Tests
    {
        [TestMethod]
        public void TestBasics()
        {
            Assert.AreEqual(0, HarryPotterCalculator.GetPrice());
            Assert.AreEqual(8, HarryPotterCalculator.GetPrice(1));
            Assert.AreEqual(8, HarryPotterCalculator.GetPrice(2));
            Assert.AreEqual(8, HarryPotterCalculator.GetPrice(3));
            Assert.AreEqual(8, HarryPotterCalculator.GetPrice(4));
            Assert.AreEqual(8, HarryPotterCalculator.GetPrice(5));
            Assert.AreEqual(8 * 2, HarryPotterCalculator.GetPrice(1, 1));
            Assert.AreEqual(8 * 3, HarryPotterCalculator.GetPrice(2, 2, 2));
        }


        [TestMethod]
        public void TestSimpleDiscounts()
        {
            Assert.AreEqual(8 * 2 * 0.95m, HarryPotterCalculator.GetPrice(1, 2));
            Assert.AreEqual(8 * 3 * 0.9m, HarryPotterCalculator.GetPrice(1, 3, 5));
            Assert.AreEqual(8 * 4 * 0.8m, HarryPotterCalculator.GetPrice(1, 2, 3, 5));
            Assert.AreEqual(8 * 5 * 0.75m, HarryPotterCalculator.GetPrice(1, 2, 3, 4, 5));
        }


        [TestMethod]
        public void TestSeveralDiscounts()
        {
            Assert.AreEqual(8 + (8 * 2 * 0.95m), HarryPotterCalculator.GetPrice(1, 1, 2));
            Assert.AreEqual(2 * (8 * 2 * 0.95m), HarryPotterCalculator.GetPrice(1, 1, 2, 2));
            Assert.AreEqual((8 * 4 * 0.8m) + (8 * 2 * 0.95m), HarryPotterCalculator.GetPrice(1, 1, 2, 3, 3, 4));
            Assert.AreEqual(8 + (8 * 5 * 0.75m), HarryPotterCalculator.GetPrice(1, 2, 2, 3, 4, 5));
        }
    }
}